function [out,psnr]=ldmm_WGL_pad(y,mask,mu,outerloop,px,py,ms...
    ,ms_normal,H,scale_initial,scale_target,max_comparison)
% This version deals with the boundary better
image_scale = max(H(:))-min(H(:));
padsize_x=round(px/2);
padsize_y=round(py/2);
mask = padarray(mask,[padsize_x,padsize_y],'symmetric');
y = padarray(y,[padsize_x,padsize_y],'symmetric');
mask=mask(:);
[m,n] = size(y);
[m_original,n_original] = size(H);
y=y(:);
r=m*n;
out=cell(outerloop,1);
u=y;
y_small=y(mask);
u(~mask)=mean(u(mask))+std(u(mask))*randn(nnz(~mask),1);
x=u(~mask);
num_unsampled=length(x);
psnr=zeros(outerloop,1);
scale=scale_initial+1;
for ii=1:outerloop
    scale=max(scale-1,scale_target);
    patch=image2patch_local(reshape(u,m,n),px,py,scale,image_scale);
    tic
    W=weight_ann_local(patch,ms,ms_normal,max_comparison);
    toc
    W=max(W,W');
    tic
    %W=assemble_weight_new(W,px,py,m,n);
    W=assemble_weight_par(W,px,py,m,n);
    toc
    fprintf('sparsity = %f \n',nnz(W)/size(W,1)^2)
    D=sum(W,2);
    D=sparse(1:r,1:r,D,r,r);
    L=D-W;
    mat_2=mu*W(~mask,mask)-2*L(~mask,mask);
    delta=sum(W(~mask,mask),2);
    delta=sparse(1:num_unsampled,1:num_unsampled,delta,num_unsampled,num_unsampled);
    mat_1=2*L(~mask,~mask)+mu*delta;
    b=mat_2*y_small;
    tic
    [x,flag,relres,iter] = pcg(mat_1,b,1e-6,100,[],[],x);
    toc
    u(~mask)=x;
    fprintf('step = %d, flag = %d, relres = %f, iter = %d \n',ii,flag,relres,iter)
    image = reshape(u,m,n);
    image = image(padsize_x+1:padsize_x+m_original,padsize_y+1:padsize_y+n_original);
    figure(ii);
    imshow(image)
    %imagesc(reshape(u,m,n),[0 1]);
    %colormap jet
    drawnow
    temp=sum(sum((image-H).^2))/m_original/n_original;
    psnr(ii)=10*log(1^2/temp)/log(10);
    fprintf('step = %d, psnr = %f \n',ii,psnr(ii))
    out{ii}=image;
end
    
    
    