%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2d inpainting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run vlfeat-0.9.21/toolbox/vl_setup
close all
clear
load data_barbara_10
% H is the original image
% mask = true are the sampled points
% y is the sampled image, i.e. y = H.*mask
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% parameter setting (for scientific data)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rate = .1;                      % sample rate              
ms = 20;                        % number of non-zero weight for every pixel
ms_normal = 10;                 % normalizing factor, usually half of ms
scale_initial = 10;             % initial semi-local weight
                                % set to 10
scale_target = 3;               % final semi-local weight
                                % set to 3
max_comparison = 2^10;          % number of comparison for kd-tree
outerloop=15;                   
mu = 1/rate -1;
px=8;                           % patch size
py=8;                           % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LDMM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
[out,psnr]=ldmm_WGL_pad(y,mask,mu,outerloop,px,py,ms,ms_normal,H...
    ,scale_initial,scale_target,max_comparison);
toc;




